diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-admin/network/site-settings.php ./wordpress-3.3/wp-admin/network/site-settings.php
*** ./wordpress-3.2.1/wp-admin/network/site-settings.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-admin/network/site-settings.php	2011-11-30 20:22:07.000000000 -0600
***************
*** 16,27 ****
  if ( ! current_user_can( 'manage_sites' ) )
  	wp_die( __( 'You do not have sufficient permissions to edit this site.' ) );
  
! add_contextual_help($current_screen,
! 	'<p>' . __('The menu is for editing information specific to individual sites, particularly if the admin area of a site is unavailable.') . '</p>' .
! 	'<p>' . __('<strong>Info</strong> - The domain and path are rarely edited as this can cause the site to not work properly. The Registered date and Last Updated date are displayed. Network admins can mark a site as archived, spam, deleted and mature, to remove from public listings or disable.') . '</p>' .
! 	'<p>' . __('<strong>Users</strong> - This displays the users associated with this site. You can also change their role, reset their password, or remove them from the site. Removing the user from the site does not remove the user from the network.') . '</p>' .
! 	'<p>' . sprintf( __('<strong>Themes</strong> - This area shows themes that are not already enabled across the network. Enabling a theme in this menu makes it accessible to this site. It does not activate the theme, but allows it to show in the site&#8217;s Appearance menu. To enable a theme for the entire network, see the <a href="%s">Network Themes</a> screen.' ), network_admin_url( 'themes.php' ) ) . '</p>' .
! 	'<p>' . __('<strong>Settings</strong> - This page shows a list of all settings associated with this site. Some are created by WordPress and others are created by plugins you activate. Note that some fields are grayed out and say Serialized Data. You cannot modify these values due to the way the setting is stored in the database.') . '</p>' .
  	'<p><strong>' . __('For more information:') . '</strong></p>' .
  	'<p>' . __('<a href="http://codex.wordpress.org/Network_Admin_Sites_Screens" target="_blank">Documentation on Site Management</a>') . '</p>' .
  	'<p>' . __('<a href="http://wordpress.org/support/forum/multisite/" target="_blank">Support Forums</a>') . '</p>'
--- 16,33 ----
  if ( ! current_user_can( 'manage_sites' ) )
  	wp_die( __( 'You do not have sufficient permissions to edit this site.' ) );
  
! get_current_screen()->add_help_tab( array(
! 	'id'      => 'overview',
! 	'title'   => __('Overview'),
! 	'content' =>
! 		'<p>' . __('The menu is for editing information specific to individual sites, particularly if the admin area of a site is unavailable.') . '</p>' .
! 		'<p>' . __('<strong>Info</strong> - The domain and path are rarely edited as this can cause the site to not work properly. The Registered date and Last Updated date are displayed. Network admins can mark a site as archived, spam, deleted and mature, to remove from public listings or disable.') . '</p>' .
! 		'<p>' . __('<strong>Users</strong> - This displays the users associated with this site. You can also change their role, reset their password, or remove them from the site. Removing the user from the site does not remove the user from the network.') . '</p>' .
! 		'<p>' . sprintf( __('<strong>Themes</strong> - This area shows themes that are not already enabled across the network. Enabling a theme in this menu makes it accessible to this site. It does not activate the theme, but allows it to show in the site&#8217;s Appearance menu. To enable a theme for the entire network, see the <a href="%s">Network Themes</a> screen.' ), network_admin_url( 'themes.php' ) ) . '</p>' .
! 		'<p>' . __('<strong>Settings</strong> - This page shows a list of all settings associated with this site. Some are created by WordPress and others are created by plugins you activate. Note that some fields are grayed out and say Serialized Data. You cannot modify these values due to the way the setting is stored in the database.') . '</p>'
! ) );
! 
! get_current_screen()->set_help_sidebar(
  	'<p><strong>' . __('For more information:') . '</strong></p>' .
  	'<p>' . __('<a href="http://codex.wordpress.org/Network_Admin_Sites_Screens" target="_blank">Documentation on Site Management</a>') . '</p>' .
  	'<p>' . __('<a href="http://wordpress.org/support/forum/multisite/" target="_blank">Support Forums</a>') . '</p>'
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-admin/network/sites.php ./wordpress-3.3/wp-admin/network/sites.php
*** ./wordpress-3.2.1/wp-admin/network/sites.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-admin/network/sites.php	2011-12-10 12:26:48.000000000 -0600
***************
*** 24,40 ****
  
  add_screen_option( 'per_page', array('label' => _x( 'Sites', 'sites per page (screen options)' )) );
  
! add_contextual_help($current_screen,
! 	'<p>' . __('Add New takes you to the Add New Site screen. You can search for a site by Name, ID number, or IP address. Screen Options allows you to choose how many sites to display on one page.') . '</p>' .
! 	'<p>' . __('This is the main table of all sites on this network. Switch between list and excerpt views by using the icons above the right side of the table.') . '</p>' .
! 	'<p>' . __('Hovering over each site reveals seven options (three for the primary site):') . '</p>' .
! 	'<ul><li>' . __('An Edit link to a separate Edit Site screen.') . '</li>' .
! 	'<li>' . __('Dashboard leads to the Dashboard for that site.') . '</li>' .
! 	'<li>' . __('Deactivate, Archive, and Spam which lead to confirmation screens. These actions can be reversed later.') . '</li>' .
! 	'<li>' . __('Delete which is a permanent action after the confirmation screens.') . '</li>' .
! 	'<li>' . __('Visit to go to the frontend site live.') . '</li></ul>' .
! 	'<p>' . __('The site ID is used internally, and is not shown on the front end of the site or to users/viewers.') . '</p>' .
! 	'<p>' . __('Clicking on bold headings can re-sort this table.') . '</p>' .
  	'<p><strong>' . __('For more information:') . '</strong></p>' .
  	'<p>' . __('<a href="http://codex.wordpress.org/Network_Admin_Sites_Screens" target="_blank">Documentation on Site Management</a>') . '</p>' .
  	'<p>' . __('<a href="http://wordpress.org/support/forum/multisite/" target="_blank">Support Forums</a>') . '</p>'
--- 24,46 ----
  
  add_screen_option( 'per_page', array('label' => _x( 'Sites', 'sites per page (screen options)' )) );
  
! get_current_screen()->add_help_tab( array(
! 	'id'      => 'overview',
! 	'title'   => __('Overview'),
! 	'content' =>
! 		'<p>' . __('Add New takes you to the Add New Site screen. You can search for a site by Name, ID number, or IP address. Screen Options allows you to choose how many sites to display on one page.') . '</p>' .
! 		'<p>' . __('This is the main table of all sites on this network. Switch between list and excerpt views by using the icons above the right side of the table.') . '</p>' .
! 		'<p>' . __('Hovering over each site reveals seven options (three for the primary site):') . '</p>' .
! 		'<ul><li>' . __('An Edit link to a separate Edit Site screen.') . '</li>' .
! 		'<li>' . __('Dashboard leads to the Dashboard for that site.') . '</li>' .
! 		'<li>' . __('Deactivate, Archive, and Spam which lead to confirmation screens. These actions can be reversed later.') . '</li>' .
! 		'<li>' . __('Delete which is a permanent action after the confirmation screens.') . '</li>' .
! 		'<li>' . __('Visit to go to the frontend site live.') . '</li></ul>' .
! 		'<p>' . __('The site ID is used internally, and is not shown on the front end of the site or to users/viewers.') . '</p>' .
! 		'<p>' . __('Clicking on bold headings can re-sort this table.') . '</p>'
! ) );
! 
! get_current_screen()->set_help_sidebar(
  	'<p><strong>' . __('For more information:') . '</strong></p>' .
  	'<p>' . __('<a href="http://codex.wordpress.org/Network_Admin_Sites_Screens" target="_blank">Documentation on Site Management</a>') . '</p>' .
  	'<p>' . __('<a href="http://wordpress.org/support/forum/multisite/" target="_blank">Support Forums</a>') . '</p>'
***************
*** 42,47 ****
--- 48,243 ----
  
  $id = isset( $_REQUEST['id'] ) ? intval( $_REQUEST['id'] ) : 0;
  
+ if ( isset( $_GET['action'] ) ) {
+ 	do_action( 'wpmuadminedit' , '' );
+ 
+ 	switch ( $_GET['action'] ) {
+ 		case 'updateblog':
+ 			// No longer used.
+ 		break;
+ 
+ 		case 'deleteblog':
+ 			check_admin_referer('deleteblog');
+ 			if ( ! ( current_user_can( 'manage_sites' ) && current_user_can( 'delete_sites' ) ) )
+ 				wp_die( __( 'You do not have permission to access this page.' ) );
+ 
+ 			if ( $id != '0' && $id != $current_site->blog_id && current_user_can( 'delete_site', $id ) ) {
+ 				wpmu_delete_blog( $id, true );
+ 				wp_safe_redirect( add_query_arg( array( 'updated' => 'true', 'action' => 'delete' ), wp_get_referer() ) );
+ 			} else {
+ 				wp_safe_redirect( add_query_arg( array( 'updated' => 'true', 'action' => 'not_deleted' ), wp_get_referer() ) );
+ 			}
+ 
+ 			exit();
+ 		break;
+ 
+ 		case 'allblogs':
+ 			if ( ( isset( $_POST['action'] ) || isset( $_POST['action2'] ) ) && isset( $_POST['allblogs'] ) ) {
+ 				check_admin_referer( 'bulk-sites' );
+ 
+ 				if ( ! current_user_can( 'manage_sites' ) )
+ 					wp_die( __( 'You do not have permission to access this page.' ) );
+ 
+ 				if ( $_GET['action'] != -1 || $_POST['action2'] != -1 )
+ 					$doaction = $_POST['action'] != -1 ? $_POST['action'] : $_POST['action2'];
+ 
+ 				$blogfunction = '';
+ 
+ 				foreach ( (array) $_POST['allblogs'] as $key => $val ) {
+ 					if ( $val != '0' && $val != $current_site->blog_id ) {
+ 						switch ( $doaction ) {
+ 							case 'delete':
+ 								if ( ! current_user_can( 'delete_site', $val ) )
+ 									wp_die( __( 'You are not allowed to delete the site.' ) );
+ 								$blogfunction = 'all_delete';
+ 								wpmu_delete_blog( $val, true );
+ 							break;
+ 
+ 							case 'spam':
+ 								$blogfunction = 'all_spam';
+ 								update_blog_status( $val, 'spam', '1' );
+ 								set_time_limit( 60 );
+ 							break;
+ 
+ 							case 'notspam':
+ 								$blogfunction = 'all_notspam';
+ 								update_blog_status( $val, 'spam', '0' );
+ 								set_time_limit( 60 );
+ 							break;
+ 						}
+ 					} else {
+ 						wp_die( __( 'You are not allowed to change the current site.' ) );
+ 					}
+ 				}
+ 
+ 				wp_safe_redirect( add_query_arg( array( 'updated' => 'true', 'action' => $blogfunction ), wp_get_referer() ) );
+ 			} else {
+ 				wp_redirect( network_admin_url( 'sites.php' ) );
+ 			}
+ 			exit();
+ 		break;
+ 
+ 		case 'archiveblog':
+ 			check_admin_referer( 'archiveblog' );
+ 			if ( ! current_user_can( 'manage_sites' ) )
+ 				wp_die( __( 'You do not have permission to access this page.' ) );
+ 
+ 			update_blog_status( $id, 'archived', '1' );
+ 			wp_safe_redirect( add_query_arg( array( 'updated' => 'true', 'action' => 'archive' ), wp_get_referer() ) );
+ 			exit();
+ 		break;
+ 
+ 		case 'unarchiveblog':
+ 			check_admin_referer( 'unarchiveblog' );
+ 			if ( ! current_user_can( 'manage_sites' ) )
+ 				wp_die( __( 'You do not have permission to access this page.' ) );
+ 
+ 			update_blog_status( $id, 'archived', '0' );
+ 			wp_safe_redirect( add_query_arg( array( 'updated' => 'true', 'action' => 'unarchive' ), wp_get_referer() ) );
+ 			exit();
+ 		break;
+ 
+ 		case 'activateblog':
+ 			check_admin_referer( 'activateblog' );
+ 			if ( ! current_user_can( 'manage_sites' ) )
+ 				wp_die( __( 'You do not have permission to access this page.' ) );
+ 
+ 			update_blog_status( $id, 'deleted', '0' );
+ 			do_action( 'activate_blog', $id );
+ 			wp_safe_redirect( add_query_arg( array( 'updated' => 'true', 'action' => 'activate' ), wp_get_referer() ) );
+ 			exit();
+ 		break;
+ 
+ 		case 'deactivateblog':
+ 			check_admin_referer( 'deactivateblog' );
+ 			if ( ! current_user_can( 'manage_sites' ) )
+ 				wp_die( __( 'You do not have permission to access this page.' ) );
+ 
+ 			do_action( 'deactivate_blog', $id );
+ 			update_blog_status( $id, 'deleted', '1' );
+ 			wp_safe_redirect( add_query_arg( array( 'updated' => 'true', 'action' => 'deactivate' ), wp_get_referer() ) );
+ 			exit();
+ 		break;
+ 
+ 		case 'unspamblog':
+ 			check_admin_referer( 'unspamblog' );
+ 			if ( ! current_user_can( 'manage_sites' ) )
+ 				wp_die( __( 'You do not have permission to access this page.' ) );
+ 
+ 			update_blog_status( $id, 'spam', '0' );
+ 			wp_safe_redirect( add_query_arg( array( 'updated' => 'true', 'action' => 'unspam' ), wp_get_referer() ) );
+ 			exit();
+ 		break;
+ 
+ 		case 'spamblog':
+ 			check_admin_referer( 'spamblog' );
+ 			if ( ! current_user_can( 'manage_sites' ) )
+ 				wp_die( __( 'You do not have permission to access this page.' ) );
+ 
+ 			update_blog_status( $id, 'spam', '1' );
+ 			wp_safe_redirect( add_query_arg( array( 'updated' => 'true', 'action' => 'spam' ), wp_get_referer() ) );
+ 			exit();
+ 		break;
+ 
+ 		case 'unmatureblog':
+ 			check_admin_referer( 'unmatureblog' );
+ 			if ( ! current_user_can( 'manage_sites' ) )
+ 				wp_die( __( 'You do not have permission to access this page.' ) );
+ 
+ 			update_blog_status( $id, 'mature', '0' );
+ 			wp_safe_redirect( add_query_arg( array( 'updated' => 'true', 'action' => 'unmature' ), wp_get_referer() ) );
+ 			exit();
+ 		break;
+ 
+ 		case 'matureblog':
+ 			check_admin_referer( 'matureblog' );
+ 			if ( ! current_user_can( 'manage_sites' ) )
+ 				wp_die( __( 'You do not have permission to access this page.' ) );
+ 
+ 			update_blog_status( $id, 'mature', '1' );
+ 			wp_safe_redirect( add_query_arg( array( 'updated' => 'true', 'action' => 'mature' ), wp_get_referer() ) );
+ 			exit();
+ 		break;
+ 
+ 		// Common
+ 		case 'confirm':
+ 			check_admin_referer( 'confirm' );
+ 			if ( !headers_sent() ) {
+ 				nocache_headers();
+ 				header( 'Content-Type: text/html; charset=utf-8' );
+ 			}
+ 			if ( $current_site->blog_id == $id )
+ 				wp_die( __( 'You are not allowed to change the current site.' ) );
+ 			?>
+ 			<!DOCTYPE html>
+ 			<html xmlns="http://www.w3.org/1999/xhtml" <?php if ( function_exists( 'language_attributes' ) ) language_attributes(); ?>>
+ 				<head>
+ 					<title><?php _e( 'WordPress &rsaquo; Confirm your action' ); ?></title>
+ 
+ 					<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
+ 					<?php
+ 					wp_admin_css( 'install', true );
+ 					wp_admin_css( 'ie', true );
+ 					?>
+ 				</head>
+ 				<body>
+ 					<h1 id="logo"><img alt="WordPress" src="<?php echo esc_attr( admin_url( 'images/wordpress-logo.png' ) ); ?>" /></h1>
+ 					<form action="sites.php?action=<?php echo esc_attr( $_GET['action2'] ) ?>" method="post">
+ 						<input type="hidden" name="action" value="<?php echo esc_attr( $_GET['action2'] ) ?>" />
+ 						<input type="hidden" name="id" value="<?php echo esc_attr( $id ); ?>" />
+ 						<input type="hidden" name="_wp_http_referer" value="<?php echo esc_attr( wp_get_referer() ); ?>" />
+ 						<?php wp_nonce_field( $_GET['action2'], '_wpnonce', false ); ?>
+ 						<p><?php echo esc_html( stripslashes( $_GET['msg'] ) ); ?></p>
+ 						<?php submit_button( __('Confirm'), 'button' ); ?>
+ 					</form>
+ 				</body>
+ 			</html>
+ 			<?php
+ 			exit();
+ 		break;
+ 	}
+ }
+ 
  $msg = '';
  if ( isset( $_REQUEST['updated'] ) && $_REQUEST['updated'] == 'true' && ! empty( $_REQUEST['action'] ) ) {
  	switch ( $_REQUEST['action'] ) {
***************
*** 109,115 ****
  <input type="hidden" name="action" value="blogs" />
  </form>
  
! <form id="form-site-list" action="edit.php?action=allblogs" method="post">
  	<?php $wp_list_table->display(); ?>
  </form>
  </div>
--- 305,311 ----
  <input type="hidden" name="action" value="blogs" />
  </form>
  
! <form id="form-site-list" action="sites.php?action=allblogs" method="post">
  	<?php $wp_list_table->display(); ?>
  </form>
  </div>
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-admin/network/site-themes.php ./wordpress-3.3/wp-admin/network/site-themes.php
*** ./wordpress-3.2.1/wp-admin/network/site-themes.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-admin/network/site-themes.php	2011-12-10 12:26:48.000000000 -0600
***************
*** 21,32 ****
  if ( ! current_user_can( 'manage_sites' ) )
  	wp_die( __( 'You do not have sufficient permissions to manage themes for this site.' ) );
  
! add_contextual_help($current_screen,
! 	'<p>' . __('The menu is for editing information specific to individual sites, particularly if the admin area of a site is unavailable.') . '</p>' .
! 	'<p>' . __('<strong>Info</strong> - The domain and path are rarely edited as this can cause the site to not work properly. The Registered date and Last Updated date are displayed. Network admins can mark a site as archived, spam, deleted and mature, to remove from public listings or disable.') . '</p>' .
! 	'<p>' . __('<strong>Users</strong> - This displays the users associated with this site. You can also change their role, reset their password, or remove them from the site. Removing the user from the site does not remove the user from the network.') . '</p>' .
! 	'<p>' . sprintf( __('<strong>Themes</strong> - This area shows themes that are not already enabled across the network. Enabling a theme in this menu makes it accessible to this site. It does not activate the theme, but allows it to show in the site&#8217;s Appearance menu. To enable a theme for the entire network, see the <a href="%s">Network Themes</a> screen.' ), network_admin_url( 'themes.php' ) ) . '</p>' .
! 	'<p>' . __('<strong>Settings</strong> - This page shows a list of all settings associated with this site. Some are created by WordPress and others are created by plugins you activate. Note that some fields are grayed out and say Serialized Data. You cannot modify these values due to the way the setting is stored in the database.') . '</p>' .
  	'<p><strong>' . __('For more information:') . '</strong></p>' .
  	'<p>' . __('<a href="http://codex.wordpress.org/Network_Admin_Sites_Screens" target="_blank">Documentation on Site Management</a>') . '</p>' .
  	'<p>' . __('<a href="http://wordpress.org/support/forum/multisite/" target="_blank">Support Forums</a>') . '</p>'
--- 21,38 ----
  if ( ! current_user_can( 'manage_sites' ) )
  	wp_die( __( 'You do not have sufficient permissions to manage themes for this site.' ) );
  
! get_current_screen()->add_help_tab( array(
! 	'id'      => 'overview',
! 	'title'   => __('Overview'),
! 	'content' =>
! 		'<p>' . __('The menu is for editing information specific to individual sites, particularly if the admin area of a site is unavailable.') . '</p>' .
! 		'<p>' . __('<strong>Info</strong> - The domain and path are rarely edited as this can cause the site to not work properly. The Registered date and Last Updated date are displayed. Network admins can mark a site as archived, spam, deleted and mature, to remove from public listings or disable.') . '</p>' .
! 		'<p>' . __('<strong>Users</strong> - This displays the users associated with this site. You can also change their role, reset their password, or remove them from the site. Removing the user from the site does not remove the user from the network.') . '</p>' .
! 		'<p>' . sprintf( __('<strong>Themes</strong> - This area shows themes that are not already enabled across the network. Enabling a theme in this menu makes it accessible to this site. It does not activate the theme, but allows it to show in the site&#8217;s Appearance menu. To enable a theme for the entire network, see the <a href="%s">Network Themes</a> screen.' ), network_admin_url( 'themes.php' ) ) . '</p>' .
! 		'<p>' . __('<strong>Settings</strong> - This page shows a list of all settings associated with this site. Some are created by WordPress and others are created by plugins you activate. Note that some fields are grayed out and say Serialized Data. You cannot modify these values due to the way the setting is stored in the database.') . '</p>'
! ) );
! 
! get_current_screen()->set_help_sidebar(
  	'<p><strong>' . __('For more information:') . '</strong></p>' .
  	'<p>' . __('<a href="http://codex.wordpress.org/Network_Admin_Sites_Screens" target="_blank">Documentation on Site Management</a>') . '</p>' .
  	'<p>' . __('<a href="http://wordpress.org/support/forum/multisite/" target="_blank">Support Forums</a>') . '</p>'
***************
*** 39,46 ****
  $s = isset($_REQUEST['s']) ? $_REQUEST['s'] : '';
  
  // Clean up request URI from temporary args for screen options/paging uri's to work as expected.
! $temp_args = array( 'enabled', 'disabled', 'error' ); 
! $_SERVER['REQUEST_URI'] = remove_query_arg( $temp_args, $_SERVER['REQUEST_URI'] ); 
  $referer = remove_query_arg( $temp_args, wp_get_referer() );
  
  $id = isset( $_REQUEST['id'] ) ? intval( $_REQUEST['id'] ) : 0;
--- 45,52 ----
  $s = isset($_REQUEST['s']) ? $_REQUEST['s'] : '';
  
  // Clean up request URI from temporary args for screen options/paging uri's to work as expected.
! $temp_args = array( 'enabled', 'disabled', 'error' );
! $_SERVER['REQUEST_URI'] = remove_query_arg( $temp_args, $_SERVER['REQUEST_URI'] );
  $referer = remove_query_arg( $temp_args, wp_get_referer() );
  
  $id = isset( $_REQUEST['id'] ) ? intval( $_REQUEST['id'] ) : 0;
***************
*** 75,81 ****
  			check_admin_referer( 'disable-theme_' . $_GET['theme'] );
  			$theme = $_GET['theme'];
  			$action = 'disabled';
! 			$n = 1;			
  			if ( !$allowed_themes )
  				$allowed_themes = array();
  			else
--- 81,87 ----
  			check_admin_referer( 'disable-theme_' . $_GET['theme'] );
  			$theme = $_GET['theme'];
  			$action = 'disabled';
! 			$n = 1;
  			if ( !$allowed_themes )
  				$allowed_themes = array();
  			else
***************
*** 108,123 ****
  			}
  			break;
  	}
! 	
  	update_option( 'allowedthemes', $allowed_themes );
  	restore_current_blog();
! 	
! 	wp_redirect( add_query_arg( $action, $n, $referer ) );
! 	exit;	
  }
  
  if ( isset( $_GET['action'] ) && 'update-site' == $_GET['action'] ) {
! 	wp_redirect( $referer );
  	exit();
  }
  
--- 114,129 ----
  			}
  			break;
  	}
! 
  	update_option( 'allowedthemes', $allowed_themes );
  	restore_current_blog();
! 
! 	wp_safe_redirect( add_query_arg( array( 'id' => $id, $action => $n ), $referer ) );
! 	exit;
  }
  
  if ( isset( $_GET['action'] ) && 'update-site' == $_GET['action'] ) {
! 	wp_safe_redirect( $referer );
  	exit();
  }
  
***************
*** 152,164 ****
  </h3><?php
  
  if ( isset( $_GET['enabled'] ) ) {
! 	$_GET['enabled'] = absint( $_GET['enabled'] ); 
! 	echo '<div id="message" class="updated"><p>' . sprintf( _n( 'Theme enabled.', '%s themes enabled.', $_GET['enabled'] ), number_format_i18n( $_GET['enabled'] ) ) . '</p></div>'; 
! } elseif ( isset( $_GET['disabled'] ) ) { 
! 	$_GET['disabled'] = absint( $_GET['disabled'] ); 
! 	echo '<div id="message" class="updated"><p>' . sprintf( _n( 'Theme disabled.', '%s themes disabled.', $_GET['disabled'] ), number_format_i18n( $_GET['disabled'] ) ) . '</p></div>'; 
! } elseif ( isset( $_GET['error'] ) && 'none' == $_GET['error'] ) { 
! 	echo '<div id="message" class="error"><p>' . __( 'No theme selected.' ) . '</p></div>'; 
  } ?>
  
  <p><?php _e( 'Network enabled themes are not shown on this screen.' ) ?></p>
--- 158,170 ----
  </h3><?php
  
  if ( isset( $_GET['enabled'] ) ) {
! 	$_GET['enabled'] = absint( $_GET['enabled'] );
! 	echo '<div id="message" class="updated"><p>' . sprintf( _n( 'Theme enabled.', '%s themes enabled.', $_GET['enabled'] ), number_format_i18n( $_GET['enabled'] ) ) . '</p></div>';
! } elseif ( isset( $_GET['disabled'] ) ) {
! 	$_GET['disabled'] = absint( $_GET['disabled'] );
! 	echo '<div id="message" class="updated"><p>' . sprintf( _n( 'Theme disabled.', '%s themes disabled.', $_GET['disabled'] ), number_format_i18n( $_GET['disabled'] ) ) . '</p></div>';
! } elseif ( isset( $_GET['error'] ) && 'none' == $_GET['error'] ) {
! 	echo '<div id="message" class="error"><p>' . __( 'No theme selected.' ) . '</p></div>';
  } ?>
  
  <p><?php _e( 'Network enabled themes are not shown on this screen.' ) ?></p>
